public class FProdutividade extends Funcionario {
  private double valor;
  private int producao;
  
  public double getValor() {
    return valor;
  }
  
  public int getProducao() {
    return producao;
  }
  
  public void setValor(double valor) throws EDadoInvalido {
    if (valor <= 0)
      throw new EDadoInvalido("O valor unitrio deve ser positivo");
    
    this.valor = valor;
  }
  
  public void setValor(String valor) throws EDadoInvalido {
    try {
      setValor( Double.parseDouble(valor) );
    }
    catch (NumberFormatException nfe) {
      throw new EDadoInvalido("O valor unitrio deve ser um nmero");
    }
  }
  
  public void setProducao(int producao) throws EDadoInvalido {
    if (producao < 0)
      throw new EDadoInvalido("A producao no deve ser negativa");
    
    this.producao = producao;
  }
  
  public void setProducao(String producao) throws EDadoInvalido {
    try {
      setProducao( Integer.parseInt(producao) );
    }
    catch (NumberFormatException nfe) {
      throw new EDadoInvalido("A produo deve ser um inteiro");
    }
  }
  
  public double calcularProventos() {
    return super.getSalario() + (producao * valor);
  }
}

/********************************************************************
 * Este arquivo  parte integrante do livro identificado abaixo e  *
 * protegido pela legislao que trata dos direitos autorais.       *
 *                                                                  *
 * Ttulo:  Programao de Computadores em Java                     *
 * Autor:   Rui Rossi dos Santos                                    *
 * Editora: NovaTerra Editora e Distribuidora Ltda.                 *
 * Ano:     2014                                                    *
 ********************************************************************/